#define STACKSIZE 10000
#define safeExecution(expression) do {          \
    if( (expression) == NULL ) {                \
      perror("Oops! ");                         \
      exit(1);                                  \
    }                                           \
  }                                             \
  while(0)

 struct list {
	union {
		struct kanonas *kan;
		struct dedomeno *ded;
		struct metavlhth *met;
		struct stathera *stath;
		struct greater *great;
		struct conflict *conf;
   }types;
   //1:kanonas 2:dedomeno-literal 3:metablhth 4:sta8era 5:greater 6:Conflict
   int index;
   //	KENO
   struct list *next;
 }*data,*data2,*data3; 
  
 struct kanonas {
        //label-onoma kanona.   KENO
        char *name;
	//1: kanonas me label 2: kanonas xwris label
	int kind1;
        //1: kanonas me body 2: kanonas xwris body
        int kind2;
	//1: -> 2: => 3:~>
	int telesths;
 };
 struct dedomeno {
        //label-onoma dedomenou.
        char *name;
	//1:to kathgorhma exei not 2:den exei
	int not;
	//arguments tou kathgorhmatos-dedomenou?KENO?
	//mia lista apo metavlhtes 'h statheres
	struct list *arguments;
 };

  struct metavlhth {
	//onoma metavlhths;
	char *name;
 };
  struct stathera {
        //onoma stahtheras;
        char *name;
 };
  struct greater {
        //onoma aristerou kanona
        char *rule1;
        //onoma de3iou kanona
        char *rule2;
 };
  struct conflict {
        //panta to name=conf
        char *name;
 };
  struct general {
        //onoma "plhroforias";
        char *name;
	//1:kanonas 2:dedomeno 3:metavlhth 4:stahera 5:conflict
	int index;
	//deikths pros to epomeno stoixeio
	struct general *next;
 }*gen;
 struct list *symbol_table[STACKSIZE];
 struct list *body_table[STACKSIZE];
 struct general *general_table[4];
 int top;
 int ok;
 int namegenerator;
 int exist[5];
 /* 0:fact 1:defeasible 2:sup 3:strict 4:defeater*/
 
void insert_ded_tobodytable(struct list *);
void insert_kan_tosymboltable(struct list *);
void insert_ded_tosymboltable(struct list *);
void insert_great_tosymboltable(struct list *);
void insert_symboltable(struct list *);
void insert_info_togeneraltable(struct general *);
struct list *insert_args_to_table(char *);
struct list *lookup_bodytable(char *, struct list *);
struct list *lookup_symboltable(char *);
struct general *lookup_generaltable(char *, int);

int countelement(struct list *);
struct list *findelement(int ,struct list *);
int *find_opposite(int ,struct list *);
int find_opposite2(int ,struct list *);
int comparison(struct list *,struct list *);
int comparison2(struct list *,struct list *);
int reverse(char *);
char *itoa(int );

void print_bodytable();
void print_symboltable(void );
void produce_whitespace(int);
void produce_atomtags(struct list *,int ,int );
void produce_fact_atomtags(struct list *);
void produce_atomtags3(struct list *);
void produce_atomtags4(struct list *);
void produce_attributes(struct list *lista);
void produce_ruletags(int ,int );
void produce_greatertags(struct list *);
void produce_code(void);
void produce_exports(void);
        
void parse1(void);
struct list *copy_arguments(struct list *);
void copy_literal(int );
struct list *copy_literal2(struct list *);
void create_rule(struct list *,struct list *,struct list *,char *);
void create_head(struct list *);
void create_body(struct list *);
struct list *scan_symbol_for_conflicts(struct list *);
int find_same2_label_deafeasible(int ,struct list *);
int *find_same_label_deafeasible(int ,struct list *);
int find_same2_nolabel_deafeasible(int ,struct list *);
int *find_same_nolabel_deafeasible(int ,struct list *);
int checkifisin(struct list *,struct list *);

void parse2(void);
int scan_symbol_for_two_conflicts(struct list *,struct list *);
int whereisrule(char *);
