/* rdfs translation */
C(X):- rdf:type(X,C).
C(X):- rdfs:subClassOf(Sc,C),Sc(X).
P(X,Y):- rdfs:subPropertyOf(Sp,P),Sp(X,Y).
D(X):- rdfs:domain(P,D),P(X,Z).
R(Z):- rdfs:range(P,R),P(X,Z).

/* owl translation */

/* Equality */
D(X):- C(X),owl:equivalentClass(C,D).
C(X):- D(X),owl:equivalentClass(C,D).
P(X,Y):- Q(X,Y),owl:equivalentProperty(P,Q).
Q(X,Y):- P(X,Y),owl:equivalentProperty(P,Q).
C(X):- C(Y),owl:sameIndividualAs(X,Y).
P(X,Z):- P(X,Y), owl:sameIndividualAs(Y,Z).
P(Z,Y):- P(X,Y), owl:sameIndividualAs(X,Z).

/* Property Ckaracteristics */
P(X,Z):- P(X,Y), P(Y,Z), rdf:type(P,owl:TransitiveProperty).
P(X,Y):- P(Y,X), rdf:type(P,owl:SymmetricProperty).
P(X,Y):- Q(Y,X),owl:Inverseof(P,Q). 
Q(X,Y):- P(Y,X),owl:Inverseof(P,Q). 


/* Property Restrictions */
D(Y):- C(X),P(X,Y),rdfs:subClassOf(C,R), rdf:type(R,owl:Restriction),owl:onProperty(R,P), owl:allValuesFrom(R,D),rdf:type(D,owl:Class).
C(X):- P(X,V),rdfs:subClassOf(C,R), rdf:type(R,owl:Restriction),owl:onProperty(R,P), owl:hasValue(R,V).
P(X,V):- C(X),rdfs:subClassOf(C,R), rdf:type(R,owl:Restriction),owl:onProperty(R,P), owl:hasValue(R,V).

/* Collections */
D(X):- C1(X),C2(X),owl:IntersectionOf(D,Collect), rdf:type(Collect,Collection),memberOf(C1,Collect), mem-berOf(C2,Collect).
C1(X):- D(X),owl:IntersectionOf(D,Collect), rdf:type(Collect,Collection),memberOf(C1,Collect), mem-berOf(C2,Collect).
C2(X):- D(X),owl:IntersectionOf(D,Collect), rdf:type(Collect,Collection),memberOf(C1,Collect), mem-berOf(C2,Collect).
C(X):- owl:oneOf(C,Collect), rdf:type(Collect,Collection),memberOf(X,Collect).

