%{

#include "y.tab.h"

int lineno = 1;

%}

digit                   [0-9]
number                  {digit}+
space   		[" "\t\f\v]+
character		[a-zA-Z]
diplh                   [\"]{space}*
stringa			[A-Z][A-Za-z0-9]*
stringb			[a-z][A-Za-z0-9]*
%%

defRule         { return DEFRULE; }
strictRule	{ return STRICTRULE; }
name		{ return NAME; }
fact		{ return FACT; }
head		{ return HEAD; }
body		{ return BODY; }
neg		{ return NEG; }
atom		{ return ATOM; }
predicate	{ return PREDICATE; }
term		{ return TERM; }
var		{ return VAR; }
const		{ return CONST; }
greater		{ return GREATER; }
sup		{ return SUP; }
inf		{ return INF; }
theprogram	{ return THEPROGRAM; }
"//".*$ { }
"/*"	{ 
	int c;
	while((c=input())!=EOF) {
        if(c=='*'){
		c=input();
			if (c=='/'){
				//printf("--%d--",lineno);
                    		break;
			}
			else if (c=='\n') {
				++lineno;
			}
			else
				unput(c);
			}
	else if(c=='\n')
		++lineno;
	}
	}
{diplh} { return DIPLH; }
\'      { return '\'';}
"~"     { return '~';}
"!"     { return '!';}
"@"     { return '@';}
"#"     { return '#';}
"$"     { return '$';}
"%"     { return '%';}
"^"     { return '^';}
"&"     { return '&';}
"*"     { return '*';}
"_"     { return '_';}
\\      { return '\\';}
"|"     { return '|';}
"."     { return '.';}
"?"     { return '?';}
";"     { return ';'; }
"("     { return '('; }
")"     { return ')'; }
"="     { return '='; }
":"     { return ':'; }
","     { return ','; }
"-"     { return '-'; }
">"     { return '>'; }
"<"     { return '<'; }
"/"     { return '/'; }


{number}        { return NUMBER;}
{stringa}	{ yylval.s_type=(char *)strdup(yytext); return STRINGA; }
{stringb}	{ yylval.s_type=(char *)strdup(yytext); return STRINGB; }
\n		{ lineno++; }
{space}   	{  }

%%
