%{
#include "symbol_table_xml.h"
#include <stdio.h>
#include <assert.h>

extern int lineno;
char *_atom_args,*_met_stath;
struct list *find,*find2;
char *name;
int index,epipedo,ok=1;
%}

%token STRINGB STRINGA NUMBER DIPLH
%token DEFRULE STRICTRULE NAME FACT
%token HEAD BODY NEG ATOM PREDICATE 
%token TERM VAR CONST GREATER SUP INF  THEPROGRAM 

%left STRINGA STRINGB


%start program

%union {
int i_type;
char *s_type;
char c_type;
}
%type <s_type> met_stath atom_args atom Literal atom_list Rules Dedomena Literal2
%type <s_type> STRINGA STRINGB


%%
program:	'<' THEPROGRAM '>' program2 '<' '/' THEPROGRAM '>'
		{;}
		;

program2:	Rules 
		| Dedomena
		| Greater
		| program2 Rules
		| program2 Dedomena
		| program2 Greater
		| error NUMBER { yyerrok; puts("WRONG!Wrong program component!"); ok=0;}
		;

Greater:        '<' GREATER SUP '=' DIPLH met_stath DIPLH INF '=' DIPLH met_stath DIPLH '/' '>'
                {
                /*8elw na brw an oi duo kanones uparxoun ston symbol table */
                /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
                find = lookup_symboltable($6);
                if(find == NULL){
                        printf("\nWRONG!In line %d Rule <%s> has not Defined!\n",lineno,$6);
                        ok=0;
                }
                find = lookup_symboltable($11);
                if(find == NULL){
                        printf("\nWRONG!In line %d Rule <%s> has not Defined!\n",lineno,$11);
                        ok=0;
                }
                else{
                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 5;
                        data->types.great = (struct greater*)malloc(sizeof(struct greater));
                        data->types.great->rule1 = strdup($6);
                        data->types.great->rule2 = strdup($11);
                        insert_symboltable(data);
                        ++top;
                }
                }
                ;

Dedomena:	'<' FACT '>' Literal2 '<' '/' FACT '>'
                {
                assert($$ = strdup($4));
                }
		;


Rules:	'<' DEFRULE NAME '=' DIPLH met_stath DIPLH '>' '<' HEAD '>' Literal '<' '/' HEAD '>' '<' BODY '>' atom_list '<' '/' BODY '>' '<' '/' DEFRULE '>'
        {
        /*8elw na eisagw enan kanona ston symbol table */
        /*printf("before:%d\n",top);*/
        find = lookup_symboltable($6);
        /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
        if(find == NULL){
                if(lookup_generaltable($6,3)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as Constant!\n",$6,lineno);
                        ok=0;
                }
                if(lookup_generaltable($6,2)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as variable!\n",$6,lineno);
                        ok=0;
                }
                else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 1;
                        gen->name = strdup($6);
                        insert_info_togeneraltable(gen);
                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 1;
                        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
                        data->types.kan->name = strdup($6);
                        data->types.kan->kind1 = 1;
			data->types.kan->kind2 = 1;
                        data->types.kan->telesths = 1;
                        insert_symboltable(data);
                        ++top;
                }
        }
        /*ean to brw petaw semantic la8os!*/
        else{
                printf("\nWRONG!Rule <%s> in line %d redefine!\n",$6,lineno);
                ok=0;
        }
	}
        | '<' STRICTRULE NAME '=' DIPLH met_stath DIPLH '>' '<' HEAD '>' Literal '<' '/' HEAD '>' '<' BODY '>' atom_list '<' '/' BODY '>' '<' '/' STRICTRULE '>'
        {
        /*8elw na eisagw enan kanona ston symbol table */
        find = lookup_symboltable($6);
        /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
        if(find == NULL){
                if(lookup_generaltable($6,3)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as Constant!\n",$6,lineno);
                        ok=0;
                }
                if(lookup_generaltable($6,2)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as variable!\n",$6,lineno);
                        ok=0;
                }
                else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 1;
                        gen->name = strdup($6);
                        insert_info_togeneraltable(gen);
                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 1;
                        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
                        data->types.kan->name = strdup($6);
                        data->types.kan->kind1 = 1;
			data->types.kan->kind2 = 1;
                        data->types.kan->telesths = 2;
                        insert_symboltable(data);
                        ++top;
                }
        }
        /*ean to brw petaw semantic la8os!*/
        else{
                printf("\nWRONG!Rule <%s> in line %d redefine!\n",$6,lineno);
                ok=0;
        }
        }
	| '<' DEFRULE NAME '=' DIPLH met_stath DIPLH '>' '<' HEAD '>' Literal '<' '/' HEAD '>' '<' BODY '>' '<' '/' BODY '>' '<' '/' DEFRULE '>'
        {
        /*8elw na eisagw enan kanona ston symbol table */
        find = lookup_symboltable($6);
        /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
        if(find == NULL){
                if(lookup_generaltable($6,3)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as Constant!\n",$6,lineno);
                        ok=0;
                }
                if(lookup_generaltable($6,2)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as variable!\n",$6,lineno);
                        ok=0;
                }
                else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 1;
                        gen->name = strdup($6);
                        insert_info_togeneraltable(gen);
                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 1;
                        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
                        data->types.kan->name = strdup($6);
                        data->types.kan->kind1 = 1;
			data->types.kan->kind2 = 2;
                        data->types.kan->telesths = 1;
                        insert_symboltable(data);
                        ++top;
                }
        }
        /*ean to brw petaw semantic la8os!*/
        else{
                printf("WRONG!Rule <%s> in line %d redefine!\n",$6,lineno);
                ok=0;
        }
        }
	| '<' STRICTRULE NAME '=' DIPLH met_stath DIPLH '>' '<' HEAD '>' Literal '<' '/' HEAD '>' '<' BODY '>' '<' '/' BODY '>' '<' '/' STRICTRULE '>'
        {
        /*8elw na eisagw enan kanona ston symbol table */
        find = lookup_symboltable($6);
        /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
        if(find == NULL){
                if(lookup_generaltable($6,3)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as Constant!\n",$6,lineno);
                        ok=0;
                }
                if(lookup_generaltable($6,2)!=NULL){
                        printf("\nWRONG!Rule <%s> in line %d is already defined as variable!\n",$6,lineno);
                        ok=0;
                }
                else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 1;
                        gen->name = strdup($6);
                        insert_info_togeneraltable(gen);
                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 1;
                        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
                        data->types.kan->name = strdup($6);
                        data->types.kan->kind1 = 1;
			data->types.kan->kind2 = 2;
                        data->types.kan->telesths = 2;
                        insert_symboltable(data);
                        ++top;
                }
        }
        /*ean to brw petaw semantic la8os!*/
        else{
                printf("\nWRONG!Rule <%s> in line %d redefine!\n",$6,lineno);
                ok=0;
        }
        }
        | '<' DEFRULE '>' '<' HEAD '>' Literal '<' '/' HEAD '>' '<' BODY '>' atom_list '<' '/' BODY '>' '<' '/' DEFRULE '>'
        {
        /*8elw na eisagw enan kanona xwris label ston symbol table */
        data = (struct list*)malloc(sizeof(struct list));
        data->index = 1;
        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
        data->types.kan->kind1 = 2;
	data->types.kan->kind2 = 1;
        data->types.kan->telesths = 1;
        insert_symboltable(data);
        ++top;
        }
	| '<' STRICTRULE '>' '<' HEAD '>' Literal '<' '/' HEAD '>' '<' BODY '>' atom_list '<' '/' BODY '>' '<' '/' STRICTRULE '>'
        {
        /*8elw na eisagw enan kanona xwris label ston symbol table */
        data = (struct list*)malloc(sizeof(struct list));
        data->index = 1;
        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
        data->types.kan->kind1 = 2;
	data->types.kan->kind2 = 2;
        data->types.kan->telesths = 2;
        insert_symboltable(data);
        ++top;
        }
	| '<' DEFRULE '>' '<' HEAD '>' Literal '<' '/' HEAD '>' '<' BODY '>' '<' '/' BODY '>' '<' '/' DEFRULE '>'
        {
        /*8elw na eisagw enan kanona xwris label & xwris body ston symbol table */
        data = (struct list*)malloc(sizeof(struct list));
        data->index = 1;
        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
        data->types.kan->kind1 = 2;
	data->types.kan->kind2 = 2;
        data->types.kan->telesths = 1;
        insert_symboltable(data);
        ++top;
        }
	| '<' STRICTRULE '>' '<' HEAD '>' Literal '<' '/' HEAD '>' '<' BODY '>' '<' '/' BODY '>' '<' '/' STRICTRULE '>'
        {
        /*8elw na eisagw enan kanona xwris label & xwris body ston symbol table */
        data = (struct list*)malloc(sizeof(struct list));
        data->index = 1;
        data->types.kan = (struct kanonas*)malloc(sizeof(struct kanonas));
        data->types.kan->kind1 = 2;
	data->types.kan->kind2 = 2;
        data->types.kan->telesths = 2;
        insert_symboltable(data);
        ++top;
        }
	;

			
atom_list:	Literal 
		{;}
		| atom_list Literal
		{;}
		;
			
Literal:	atom 
		;

Literal2:	'<' ATOM '>' '<' PREDICATE '>' STRINGB '<' '/' PREDICATE '>' '<' '/' ATOM '>'
                {
                if(lookup_generaltable($7,3)!=NULL){
                        printf("\nWRONG!Predicate <%s> in line %d is already defined as Constant!\n",$7,lineno);
                        ok=0;
                }
                else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 2;
                        gen->name = strdup($7);
                        insert_info_togeneraltable(gen);
                        /*8elw na eisagw enan kathgorhma ston symbol table */
                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 2;
                        data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
                        data->types.ded->name = strdup($7);
                        data->types.ded->not = 2;
                        insert_symboltable(data);
                        ++top;
                }
                assert($$ = strdup($7));
                }
		| '<' NEG '>' '<' ATOM '>' '<' PREDICATE '>' STRINGB '<' '/' PREDICATE '>' '<' '/' ATOM '>' '<' '/' NEG '>'
                {
                if(lookup_generaltable($10,3)!=NULL){
                        printf("\nWRONG!Predicate <%s> in line %d is already defined as Constant!\n",$10,lineno);
                        ok=0;
                }
                else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 2;
                        gen->name = strdup($10);
                        insert_info_togeneraltable(gen);
                        /*8elw na eisagw enan kathgorhma ston symbol table */
                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 2;
                        data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
                        data->types.ded->name = strdup($10);
                        data->types.ded->not = 1;
                        insert_symboltable(data);
                        ++top;
                }
                assert($$ = strdup($10));
                }
		| '<' ATOM '>' '<' PREDICATE '>' STRINGB '<' '/' PREDICATE '>' atom_args '<' '/' ATOM '>'
                {
                if(lookup_generaltable($7,3)!=NULL){
                        printf("\nWRONG!Predicate <%s> in line %d is already defined as Constant!\n",$7,lineno);
                        ok=0;
                }
                else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 2;
                        gen->name = strdup($7);
                        insert_info_togeneraltable(gen);
                        /*8elw na eisagw enan kathgorhma ston symbol table */
                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 2;
                        data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
                        data->types.ded->name = strdup($7);
                        data->types.ded->arguments = insert_args_to_table($12);
                        data->types.ded->not = 2;
                        insert_symboltable(data);
                        ++top;
                }
                assert($$ = strdup(strcat(strcat(strcat($7,strdup("(")),$12),strdup(")"))));
                }
		| '<' NEG '>' '<' ATOM '>' '<' PREDICATE '>' STRINGB '<' '/' PREDICATE '>' atom_args '<' '/' ATOM '>' '<' '/' NEG '>'
                {
                if(lookup_generaltable($10,3)!=NULL){
                        printf("\nWRONG!Predicate <%s> in line %d is already defined as Constant!\n",$10,lineno);
                        ok=0;
                }
                else {
                        gen = (struct general*)malloc(sizeof(struct general));
                        gen->index = 2;
                        gen->name = strdup($10);
                        insert_info_togeneraltable(gen);
                        /*8elw na eisagw enan kathgorhma ston symbol table */
                        data = (struct list*)malloc(sizeof(struct list));
                        data->index = 2;
                        data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
                        data->types.ded->name = strdup($10);
                        data->types.ded->arguments = insert_args_to_table($15);
                        data->types.ded->not = 1;
                        insert_symboltable(data);
                        ++top;
                }
                assert($$ = strdup(strcat(strcat(strcat($10,strdup("(")),$15),strdup(")"))));
                }
		;


atom:		'<' ATOM '>' '<' PREDICATE '>' STRINGB '<' '/' PREDICATE '>' '<' '/' ATOM '>' 
                {
                /*8elw na eisagw enan kathgorhma ston body table */
                find = lookup_bodytable($7,body_table[top]);
                /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
                if(find == NULL){
                        if(lookup_generaltable($7,3)!=NULL){
                                printf("\nWRONG!Predicate <%s> in line %d is already defined as Constant!\n",$7,lineno);
                                ok=0;
                        }
                        else {
                                gen = (struct general*)malloc(sizeof(struct general));
                                gen->index = 2;
                                gen->name = strdup($7);
                                insert_info_togeneraltable(gen);
                                data = (struct list*)malloc(sizeof(struct list));
                                data->index = 2;
                                data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
                                data->types.ded->name = strdup($7);
                                data->types.ded->not = 2;
                                insert_ded_tobodytable(data);
                        }
                }
                /*ean to brw petaw semantic la8os!*/
                else{
                        printf("\nWRONG!In line %d Predicate <%s> redefine!\n",lineno,$7);
                        ok=0;
                }
                assert($$ = strdup($7));
                }
		| '<' NEG '>' '<' ATOM '>' '<' PREDICATE '>' STRINGB '<' '/' PREDICATE '>' '<' '/' ATOM '>' '<' '/' NEG '>'
                {
                /*8elw na eisagw enan kathgorhma ston body table */
                if(body_table[top])
                        find = lookup_bodytable($10,body_table[top]);
                else
                        find = lookup_bodytable($10,body_table[top]);
                /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
                if(find == NULL){
                        if(lookup_generaltable($10,3)!=NULL){
                                printf("\nWRONG!Predicate <%s> in line %d is already defined as Constant!\n",$10,lineno);
                                ok=0;
                        }
                        else {
                                gen = (struct general*)malloc(sizeof(struct general));
                                gen->index = 2;
                                gen->name = strdup($10);
                                insert_info_togeneraltable(gen);
                                data = (struct list*)malloc(sizeof(struct list));
                                data->index = 2;
                                data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
                                data->types.ded->name = strdup($10);
                                data->types.ded->not = 1;
                                insert_ded_tobodytable(data);
                        }
                }
                /*ean to brw petaw semantic la8os!*/
                else{
                        printf("\nWRONG!In line %d predicate <%s> redefine!\n",lineno,$10);
                        ok=0;
                }
		assert($$ = strdup($10));
                }
		| '<' ATOM '>' '<' PREDICATE '>' STRINGB '<' '/' PREDICATE '>' atom_args '<' '/' ATOM '>'
                {
                /*8elw na eisagw enan kathgorhma ston body table */
                find = lookup_bodytable($7,body_table[top]);
                /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
                if(find == NULL){
                        if(lookup_generaltable($7,3)!=NULL){
                        printf("\nWRONG!Predicate <%s> in line %d is already defined as Constant!\n",$7,lineno);
                                ok=0;
                        }
                        else {
                                gen = (struct general*)malloc(sizeof(struct general));
                                gen->index = 2;
                                gen->name = strdup($7);
                                insert_info_togeneraltable(gen);
                                data = (struct list*)malloc(sizeof(struct list));
                                data->index = 2;
                                data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
                                data->types.ded->name = strdup($7);
                                data->types.ded->arguments = insert_args_to_table($12);
                                data->types.ded->not = 2;
                                insert_ded_tobodytable(data);
                        }
                }
                /*ean to brw petaw semantic la8os!*/
                else{
                        printf("\nWRONG!In line %d predicate <%s> redefine!\n",lineno,$7);
                        ok=0;
                }
		assert($$ = strdup(strcat(strcat(strcat($7,strdup("(")),$12),strdup(")"))));
                }
		| '<' NEG '>' '<' ATOM '>' '<' PREDICATE '>' STRINGB '<' '/' PREDICATE '>' atom_args '<' '/' ATOM '>' '<' '/' NEG '>'
                {
                /*8elw na eisagw enan kathgorhma ston body table */
                find = lookup_bodytable($10,body_table[top]);
                /*ean den brw to met_stath mesa sthn list tote eisagw ton kanona*/
                if(find == NULL){
                        if(lookup_generaltable($10,3)!=NULL){
                                printf("\nWRONG!Predicate <%s> in line %d is already defined as Constant!\n",$10,lineno);
                                ok=0;
                        }
                        else {
                                gen = (struct general*)malloc(sizeof(struct general));
                                gen->index = 2;
                                gen->name = strdup($10);
                                insert_info_togeneraltable(gen);
                                data = (struct list*)malloc(sizeof(struct list));
                                data->index = 2;
                                data->types.ded = (struct dedomeno*)malloc(sizeof(struct dedomeno));
                                data->types.ded->name = strdup($10);
                                data->types.ded->arguments = insert_args_to_table($15);
                                data->types.ded->not = 1;
                                insert_ded_tobodytable(data);
                        }
                }
                /*ean to brw petaw semantic la8os!*/
                else{
                        printf("\nWRONG!In line %d Predicate <%s> redefine!\n",lineno,$10);
                        ok=0;
                }
		assert($$ = strdup(strcat(strcat(strcat($10,strdup("(")),$15),strdup(")"))));
                }
		;

atom_args:	'<' TERM '>' '<' CONST '>' STRINGB '<' '/' CONST '>' '<' '/' TERM '>'
		{
		assert($$ = strdup($7));
		}
		| '<' TERM '>' '<' VAR '>' STRINGA '<' '/' VAR '>' '<' '/' TERM '>'
		{
		assert($$ = strdup($7));
		}
		| atom_args '<' TERM '>' '<' CONST '>' STRINGB '<' '/' CONST '>' '<' '/' TERM '>' 
		{
		assert($$ = strdup(strcat(strcat($8,","),$1)));
		}
		| atom_args '<' TERM '>' '<' VAR '>' STRINGA '<' '/' VAR '>' '<' '/' TERM '>' 
		{
		assert($$ = strdup(strcat(strcat($8,","),$1)));
		}
		;

met_stath:	STRINGB
		{
		assert($$ = strdup($1)); 
		}
		| STRINGA
		{
		assert($$ = strdup($1)); 
		}
		;

%%
#include <stdio.h>

void yyerror(char *s){
  printf("\nWRONG!Syntax error in line %d\n ", lineno);
  ok=0;
}

int main() {
int i;
  yyparse();
	/*for(i=0; i<=top; ++i){
		print_bodytable(body_table[i]);
		printf("i=%d\n",i);
		puts("---------");
	}
	printf("\n---top = %d---\n",top);
	print_symboltable();*/

	/* PARAGWGH APOTELESMATWN*/
	if(ok==1)
		produce_code();
	return(0);
}
/*-------------------------------------------------------------------------*/
/* paragei code gia olo to programma					   */
/*-------------------------------------------------------------------------*/
void produce_code(void){
int i;

for(i=0; i<top; ++i){
	//kanonas
	if(symbol_table[i]->index==1){
		//kanonas me label
		if(symbol_table[i]->types.kan->kind1==1){
			//kanonas me body
			if(symbol_table[i]->types.kan->kind2==1){
				//tou stul	R2: p(x,a),u -> l(w)
				if(symbol_table[i]->types.kan->telesths==2)
					produce_rules(1,i);
				//tou stul     R2: p(x,a),u => l(w)
				else if(symbol_table[i]->types.kan->telesths==1)
                                        produce_rules(2,i);
			}
                        //kanonas xwris body
                        else if(symbol_table[i]->types.kan->kind2==2){
                                //tou stul     R2:  -> l(w)
                                if(symbol_table[i]->types.kan->telesths==2)
                                        produce_rules(3,i);
                                //tou stul     R2:  => l(w)
                                else if(symbol_table[i]->types.kan->telesths==1)
                                        produce_rules(4,i);
                        }
		}
                //kanonas xwris label
                else if(symbol_table[i]->types.kan->kind1==2){
                        //kanonas me body
                        if(symbol_table[i]->types.kan->kind2==1){
                                //tou stul      p(x,a),u -> l(w)
                                if(symbol_table[i]->types.kan->telesths==2)
                                        produce_rules(5,i);
                                //tou stul      p(x,a),u => l(w)
                                else if(symbol_table[i]->types.kan->telesths==1)
                                        produce_rules(6,i);
                        }
                        //kanonas xwris body
                        else if(symbol_table[i]->types.kan->kind2==2){
				//tou stul      -> l(w)
                                if(symbol_table[i]->types.kan->telesths==2)
                                        produce_rules(7,i);
                                //tou stul      => l(w)
                                else if(symbol_table[i]->types.kan->telesths==1)
                                        produce_rules(8,i);
                        }
		}
	}
        //gegonos
        else if(symbol_table[i]->index==2){
                produce_atoms(symbol_table[i],2);
        }
	//greater
	else if(symbol_table[i]->index=5){
		printf("%s>%s.\n",symbol_table[i]->types.great->rule1,symbol_table[i]->types.great->rule2);
	}
}
}
/*-------------------------------------------------------------------------*/
/* paragei atom tags tou stul a(n) 'h x(ax,I,o) 'h -k			   */
/*-------------------------------------------------------------------------*/
void produce_atoms(struct list *lista,int y){
	//lista:deikths pros thn alusida pou periexei ta stoixeia
	//y:	1:atoms se enan kanona	2:atoms se ena gegonos
struct list *current;
int i,j,notflag,not;
char *temp,*name,*args;
temp = (char *)malloc(100*sizeof(char *));
//name = (char *)malloc(100*sizeof(char *));
//args = (char *)malloc(100*sizeof(char *));

  //olh h plhroforia pou xreiazomaste einai
  //1)ean exw r1>r2 'h -p(a) 2)ton deikth ston kombo
  if(!lista){
	puts("WRONG! No symbols!");
	return;
  }
name = lista->types.ded->name;
not = lista->types.ded->not;
if(not==1){
	printf("-");
}
printf("%s",name);
	
//an uparxoun argument ta tupwnw.PRSX! me antistrofh seira!
	
if(lista->types.ded->arguments!=NULL){
	printf("(");
        current = lista->types.ded->arguments;
        i = countelements(current);
        for(j=i; j>0; --j){
		current = findelement(j,lista->types.ded->arguments);
		//Metablhth
		if(current->index==3){
			printf("%s",current->types.met->name);
		}
		//sta8era
		else if(current->index==4){
			printf("%s",current->types.stath->name);
		}
		//ean uparxei 
		if(j>1)
			printf(",");
	}
	printf(")");
}
if(y==2)
	printf(".\n");
}
/*-------------------------------------------------------------------------*/
/* paragei kwdika gia kanones*/
/*-------------------------------------------------------------------------*/
void produce_rules(int kindoftags,int epipedo){
	//kindoftags 1-8:rule tags
	//epipedo:epipedo sto opoio briskomaste
struct list *lista;
int i=0,j=0;
        //tou stul      R2: p(x,a),u -> l(w)
        if(kindoftags==1){
		//tupwnoume To R2: 
		printf("%s: ",symbol_table[epipedo]->types.kan->name);
		//tupwnoume ean uparxoun ta p(x,a),u (=ta atom tags tou body)
		lista = body_table[epipedo];
                i = countelements(lista);
                for(j=i; j>1; --j){
                        lista = findelement(j-1,body_table[epipedo]);
                        produce_atoms(lista,1);
			//ean j==2 den xreiazetai , ka8ws einai to teleutaio stoixeio
			if(j>2)
				printf(",");
                }
		printf(" -> ");
		//tupwnoume to l(w)
		lista = findelement(i,body_table[epipedo]);
                produce_atoms(lista,1);
		printf(".\n");
        }
        //tou stul     R2: p(x,a),u => l(w)
        if(kindoftags==2){
                //tupwnoume To R2:
                printf("%s: ",symbol_table[epipedo]->types.kan->name);
                //tupwnoume ean uparxoun ta p(x,a),u (=ta atom tags tou body)
                lista = body_table[epipedo];
                i = countelements(lista);
                for(j=i; j>1; --j){
                        lista = findelement(j-1,body_table[epipedo]);
                        produce_atoms(lista,1);
			//ean j==2 den xreiazetai , ka8ws einai to teleutaio stoixeio
                        if(j>2)
                                printf(",");
                }
                printf(" => ");
                //tupwnoume to l(w)
                lista = findelement(i,body_table[epipedo]);
                produce_atoms(lista,1);
                printf(".\n");
        }
        //tou stul     R2:  -> l(w)
        if(kindoftags==3){
		//tupwnoume To R2:
                printf("%s: ",symbol_table[epipedo]->types.kan->name);
		printf(" -> ");
                produce_atoms(body_table[epipedo],1);
		printf(".\n");
        }
        //tou stul	R2:  => l(w)
        if(kindoftags==4){
                //tupwnoume To R2:
                printf("%s: ",symbol_table[epipedo]->types.kan->name);
                printf(" => ");
                produce_atoms(body_table[epipedo],1);
                printf(".\n");
        }
        //tou stul	p(x,a),u -> l(w)
        if(kindoftags==5){
                //tupwnoume ean uparxoun ta p(x,a),u (=ta atom tags tou body)
                lista = body_table[epipedo];
                i = countelements(lista);
                for(j=i; j>1; --j){
                        lista = findelement(j-1,body_table[epipedo]);
                        produce_atoms(lista,1);
                        //ean j==2 den xreiazetai , ka8ws einai to teleutaio stoixeio
                        if(j>2)
                                printf(",");
                }
                printf(" -> ");
                //tupwnoume to l(w)
                lista = findelement(i,body_table[epipedo]);
                produce_atoms(lista,1);
                printf(".\n");
        }
        //tou stul	p(x,a),u => l(w)
        if(kindoftags==6){
                //tupwnoume ean uparxoun ta p(x,a),u (=ta atom tags tou body)
                lista = body_table[epipedo];
                i = countelements(lista);
                for(j=i; j>1; --j){
                        lista = findelement(j-1,body_table[epipedo]);
                        produce_atoms(lista,1);
                        //ean j==2 den xreiazetai , ka8ws einai to teleutaio stoixeio
                        if(j>2)
                                printf(",");
                }
                printf(" => ");
                //tupwnoume to l(w)
                lista = findelement(i,body_table[epipedo]);
                produce_atoms(lista,1);
                printf(".\n");
        }
        //tou stul      -> l(w)
        if(kindoftags==7){
                printf(" -> ");
                produce_atoms(body_table[epipedo],1);
                printf(".\n");
        }
        //tou stul      => l(w)
        if(kindoftags==8){
		printf(" => ");
                produce_atoms(body_table[epipedo],1);
                printf(".\n");
        }
}
/*-------------------------------------------------------------------------*/
/* Sunarthsh h opoia pairnei to string a,X,AA,ka kai to topo8etei katallhla */
/* sto katallhlo table*/
/*-------------------------------------------------------------------------*/
struct list *insert_args_to_table(char *args){
struct list *current,*head;
int i,j;
//h k metraei posa attributes exei ena string px to a,X,AA,ka exei 4
int k;
char *temp;
temp = (char *)malloc(100*sizeof(char *));
head=current=NULL;

        if(args){
                j=0;
                k=0;
                while(args[j] != '\0') {
                        for (i = 0;  args[j] != ',' && args[j]!='\0';  ++i, ++j){
                                temp[i] = args[j];
                        }
                        //edw exei 3exwrisei to ena attribute px to X
                        temp[i] = '\0';
                        ++k;
                        if(args[j]!='\0')
                                ++j;
                        //Metablhth
                        if(isupper(temp[0])){
				//elegxw ean h metavlhth exei eisax8ei ws onoma kanona
				if(lookup_generaltable(temp,0)!=NULL){
					printf("\nWRONG!Variable <%s> in line %d is already defined as Rule!\n",temp,lineno);
					ok=0;
				}
				else {
					gen = (struct general*)malloc(sizeof(struct general));
					gen->index = 3;
					gen->name = strdup(temp);
					insert_info_togeneraltable(gen);
					data2 = (struct list*)malloc(sizeof(struct list));
					data2->index = 3;
					data2->types.met = (struct metavlhth*)malloc(sizeof(struct metavlhth));
                        	        data2->types.met->name = strdup(temp);
				}
                        }
                        //sta8era
                        else {
				if(lookup_generaltable(temp,1)!=NULL){
					printf("\nWRONG!Constant <%s> in line %d is already defined as Predicate!\n",temp,lineno);
					ok=0;
				}
                                if(lookup_generaltable(temp,0)!=NULL){
                                        printf("\nWRONG!Constant <%s> in line %d is already defined as Rule!\n",temp,lineno);
					ok=0;
                                }
				else {
                                        gen = (struct general*)malloc(sizeof(struct general));
                                        gen->index = 4;
                                        gen->name = strdup(temp);
                                        insert_info_togeneraltable(gen);
	                                data2 = (struct list*)malloc(sizeof(struct list));
        	                        data2->index = 4;
                	                data2->types.stath = (struct stathera*)malloc(sizeof(struct stathera));
                        	        data2->types.stath->name = strdup(temp);
				}
                        }
                        if(k==1){
				head = data2;
				head->next=NULL;
                        }
                        else {
				current = head;
				if(current==NULL)
					puts("WRONG!");
                                while(current){
					if(current->next==NULL)
						break;
					else
		                                current=current->next;
				}
				current->next=data2;
				data2->next=NULL;
                        }
                }//while
        }//if
	return(head);
}
